//
// clipeps.c
//
// EPSե;ʬ򥯥åפ
// v1.0.2-linux
//
// Copyright (C) 2003,2004 by Pakuchan.
//
// 
// 2004/07/29 - v1.0.2-linux
//                WIFEXITEDǥåΤWEXITSTATUSƤӽФ褦˽
//                ƥݥե(TEMPORARY_PBM_FILENAME)ʤäΥ顼å
//
// 2004/07/08 - v1.0.1-linux
//                linux ˰ܿ
//
// 2003/09/24 - v1.0.1
//                gswin32c.exeХѥǸƤӽФƤ
//                gswin32c.exeθƤӽФCreateProcess APIǹԤ褦ѹ
//                gswin32c.exe۾ｪλˡΥץߤ褦ѹ
//                -v (verbose) ޥɥ饤󥪥ץɲá
//                ܺ٤ʾϤ褦ѹ
//                -h (help) ޥɥ饤󥪥ץɲá
//
// 2003/05/29 - v1.0.0
//                ǥ꡼
//

#include <stdio.h>					// for rename()
#include <stdlib.h>					// for system(), atoi()
#include <string.h>					// for strncmp()
#include <stdarg.h>					// for vprintf()
#include <unistd.h>					// for chdir(), getopt()
#include <limits.h>					// for PATH_MAX
#include <sys/wait.h>				// for WIFEXITED(), WEXITSTATUS()

#define TRUE	1
#define FALSE	0

#define GHOSTSCRIPT_EXECUTABLE_NAME		"gs"

#define TEMPORARY_PBM_FILENAME			"CLIPEPS.TEMP.PBM"
#define TEMPORARY_OUTPUT_FILENAME		"CLIPEPS.OUTPUT.EPS"

#define BUFFER_SIZE						(256)

#define ERROR_BOUNDINGBOX_MISSING		(1)
#define ERROR_UNKNOWN_OPTION			(2)
#define ERROR_NEED_FILENAME				(3)
#define ERROR_FILE_NOT_OPENED			(4)
#define ERROR_INVALID_PBM_FILE			(5)
#define ERROR_NO_PIXEL					(6)
#define ERROR_OUT_OF_MEMORY				(7)
#define ERROR_CANT_EXEC_GHOSTSCRIPT		(8)

// Хѿ
int g_verbose = FALSE;		// TRUEλܺپϤ(-v ޥɥ饤󥪥ץб)

// verbose=TRUEλ˥åɽ
void VerbosePrint(const char* format, ...)
{
	if (g_verbose != FALSE)
	{
		va_list arglist;

		va_start(arglist, format);
		vprintf(format, arglist);
		va_end(arglist);
	}
}

int main(int argc, char* argv[])
{
	int   resolution = 144;			// EPSPBMѴݤβ
	int   leftX = 0, leftY = 0;		// åԥ󥰸κκɸ(ñ̤ϥԥ)
	int   rightX = 0, rightY = 0;	// åԥ󥰸ακɸ(ñ̤ϥԥ)
	FILE* fpIn;
	FILE* fpOut;
	char* filePath;
	char  fileName[PATH_MAX];

	//
	// ΥåԤ
	//
	{
		//
		// ץΥå
		//
		{
			int arg;

			optarg = NULL;
			for (;;)
			{
				arg = getopt(argc, argv, "r:vh");
				if (arg == -1) break;

				switch (arg)
				{
				case 'r':
					resolution = atoi(optarg);
					break;

				case 'v':
					g_verbose = TRUE;		// ܺɽON
					break;

				case 'h':
					printf(
						"Clipeps v1.0.2-linux\n"
						"Copyright (C) 2003, 2004 by Pakuchan.\n"
						"\n"
						"Usage: clipeps [option]... <epsfile>\n"
						"Clipping the empty space of epsfile.\n"
						"\n"
						"  -r <resolution>     use resolution for convert eps to pbm\n"
						"  -v                  verbose output\n"
						"  -h                  see this help\n"
						"\n");
					return EXIT_SUCCESS;

				default:
					return ERROR_UNKNOWN_OPTION;
				}

				optarg = NULL;
			}
		}

		//
		// ץǤʤФ
		//
		{
			if (optind == argc)
			{
				// ץꤵƤʤ
				// ɬܰ1ĤΤǥ顼
				fprintf(stderr, "clipeps: error: Must specify the filename.\n");
				return ERROR_NEED_FILENAME;
			}

			filePath = argv[optind];
		}
	}

	//
	// ϥեƱǥ쥯ȥ˥ȥǥ쥯ȥư
	//
	{
		char  directory[PATH_MAX];
		char* divide_point;

		divide_point = strrchr(filePath, '/');
		if (divide_point != NULL)
		{
			strncpy(directory, filePath, divide_point - directory);
			directory[divide_point - directory] = '\0';
			chdir(directory);

			strcpy(fileName, divide_point + 1);
		}
		else
		{
			strcpy(fileName, filePath);
		}
	}

	//
	// EPSեPBMѴ
	//
	{
		//
		// EPSե򥪡ץ󤹤
		//
		VerbosePrint("Opening EPS file \"%s\"...\n", fileName);
		{

			fpIn = fopen(fileName, "r");
			if (fpIn == NULL)
			{
				fprintf(stderr, "clipeps: error: Can't open the Encapsulated PostScript file for input - \"%s\"\n", fileName);
				return ERROR_FILE_NOT_OPENED;
			}
		}
		VerbosePrint("Opened EPS file.\n");

		//
		// EPSեBoundingBoxͤɤ߽Ф
		//
		VerbosePrint("Searching %%%%BoundingBox in the EPS file...\n");
		{
			char buffer[BUFFER_SIZE];
			int  leftX_before,  leftY_before;
			int  rightX_before, rightY_before;

			// "%%BoundingBox: "ФޤǤҤɤФ
			while (fgets(buffer, BUFFER_SIZE, fpIn) != NULL)
			{
				if (strncmp(buffer, "%%BoundingBox: ", 15) == 0)
				{
					char dummy[BUFFER_SIZE];

					if (sscanf(buffer, "%s %d %d %d %d", dummy, &leftX_before, &leftY_before, &rightX_before, &rightY_before) == 5)
					{
						goto found_boundingbox;
					}
				}
			}

			// BoundingBoxεҤʤ
			// (PSեϥ)
			fprintf(stderr, "clipeps: error: Setting boundingbox is missing (not EPS file -- maybe PS file?)\n");
			fclose(fpIn);
			return ERROR_BOUNDINGBOX_MISSING;

found_boundingbox:
			//
			// BoundingBoxͤɤ߽ФΤǡ
			// GhostScriptƤӽФPBMե
			//
			VerbosePrint("Found %%%%BoundingBox.\n");
			{
				int  width_original;
				int  height_original;
				char argument[BUFFER_SIZE];

#ifdef DEBUG
				printf("leftX_before =%d\n", leftX_before);
				printf("leftY_before =%d\n", leftY_before);
				printf("rightX_before=%d\n", rightX_before);
				printf("rightY_before=%d\n", rightY_before);
#endif

				// BoundingBoxΥȡDPIͤ顤ԥͤ׻
				VerbosePrint("Calculating the width and height of picture...\n");
				width_original  = ((rightX_before * resolution) / 72) + 1;
				height_original = ((rightY_before * resolution) / 72) + 1;
				VerbosePrint("Calculated. (width=%d, height=%d)\n", width_original, height_original);

				// ȥȲ٤Υޥɥ饤󥪥ץ
				sprintf(argument,
							"%s "
							"-dNOPAUSE "
							"-q "
							"-g%dx%d "
							"-r%d "
							"-sDEVICE=pbmraw "
							"-sOutputFile=%s "
							"\"%s\" "
							"-c showpage "
							"-c quit",
							GHOSTSCRIPT_EXECUTABLE_NAME,
							width_original,
							height_original,
							resolution,
							TEMPORARY_PBM_FILENAME,
							fileName);

				//
				// GhostScriptư
				//
				VerbosePrint("Executing GhostScript...\n");
				VerbosePrint("CommandLine: %s\n", argument);
				{
					int gs_ret;

					gs_ret = system(argument);
					if (gs_ret < 0)
					{
						fprintf(stderr, "clipeps: error: Can't execute GhostScript.\n");
						
						fclose(fpIn);
						return ERROR_CANT_EXEC_GHOSTSCRIPT;
					}

					// GhostScript۾ｪλƤ硤ߤ
					if (!WIFEXITED(gs_ret) || WEXITSTATUS(gs_ret))
					{
						fprintf(stderr, "clipeps: error: A error has been occured while GhostScript is processing.\n");
						fclose(fpIn);
						return ERROR_CANT_EXEC_GHOSTSCRIPT;
					}
				}
				VerbosePrint("Executed GhostScript\n");
			}
		}

		fclose(fpIn);
	}

	//
	// PBMե򥪡ץ󤹤
	//
	VerbosePrint("Opening temporary PBM file \"%s\"...\n", TEMPORARY_PBM_FILENAME);
	{
		fpIn = fopen(TEMPORARY_PBM_FILENAME, "rb");
		if (fpIn == NULL)
		{
			fprintf(stderr, "clipeps: error: Can't open the temporary PBM file - " TEMPORARY_PBM_FILENAME "\n");
			return ERROR_FILE_NOT_OPENED;
		}
	}
	VerbosePrint("Opened temporary PBM file.\n");

	//
	// PBMإåɤ߽ФơʤΤå
	// (ߤ̤)
	//
	{
		char buffer[BUFFER_SIZE];

		fgets(buffer, BUFFER_SIZE, fpIn);
//		if (Check_PBMHeader(buffer) == FALSE)
//		{
//			fprintf(stderr, "clipeps: error: Invalid PBM file.\n");
//			return ERROR_INVALID_PBM_FILE;
//		}
	}

	//
	// ȥԥǡɤ߽Ф
	//
	VerbosePrint("Reading width and height of PBM file...\n");
	{
		int   width;
		int   height;
		int   bytesWidth;
		char* pixelData;

		//
		// ɤ߽Ф
		// (֤ˤ륳ȹԤɤФ)
		//
		{
			char buffer[BUFFER_SIZE];

			// ȹɤФ
			fgets(buffer, BUFFER_SIZE, fpIn);
			while (buffer[0] == '#')
			{
				fgets(buffer, BUFFER_SIZE, fpIn);
			}

			// 
			sscanf(buffer, "%d %d", &width, &height);
		}
		VerbosePrint("Width=%d, Height=%d\n", width, height);

		//
		// ԥǡѥγݤȥԥǡɤ߽Ф
		//
		{
			int memorySize;

			//
			// ԥǡѥγݤȥԥǡɤ߽Ф
			//
			{
				// 1Х8ԥǳǼƤ
				bytesWidth = width / 8;
				if ((width & 7) > 0)
				{
					bytesWidth++;
				}

				// ̤η׻
				memorySize = bytesWidth * height;
				VerbosePrint("Size of memory for the pixel data of PBM file=%d [bytes]\n", memorySize);

				// 
				VerbosePrint("Allocating memory for the pixel data of PBM file...\n");
				pixelData = (char*)calloc(sizeof(char), memorySize);
				if (pixelData == NULL)
				{
					fprintf(stderr, "clipeps: error: Out of memory.\n");
					fclose(fpIn);
					return ERROR_OUT_OF_MEMORY;
				}
				VerbosePrint("Allocated.\n");
			}

			//
			// ԥǡ1饤󤺤ɤ߽Ф
			//
			{
				int y;

				VerbosePrint("Loading pixel data....\n");
				for (y = 0 ; y < height ; y++)
				{
					fread(&pixelData[y * bytesWidth + 0], sizeof(char), bytesWidth, fpIn);
				}
				VerbosePrint("Loaded pixel data.\n");
			}

		}

		//
		// ԥǡɤ߽äǥեĤ
		//
		{
			fclose(fpIn);
		}

		//
		// ԥǡBoundingBox׻
		//
		VerbosePrint("Calculating new %%%%BoundingBox value from the pixel data...\n");
		{
			//
			// 1. κü鱦˸äƽĴ٤ơ
			//    ԥ뤬Xɸõ
			//
			VerbosePrint("Start clipping phase 1...\n");
			{
				int x, y;
				int data;

				for (x = 0 ; x < bytesWidth ; x++)
				{
					for (y = 0 ; y < height ; y++)
					{
						data = pixelData[y * bytesWidth + x];
						if (data != 0)
						{
							leftX = x * 8;
/*							if      (data & 128) leftX += 0;		// ʤƤ
							else */ if (data &  64) leftX += 1;
							else if (data &  32) leftX += 2;
							else if (data &  16) leftX += 3;
							else if (data &   8) leftX += 4;
							else if (data &   4) leftX += 5;
							else if (data &   2) leftX += 6;
							else if (data &   1) leftX += 7;

							goto fin1;
						}
					}
				}

				// ¹ԤȤȤϡ
				// ԥ뤬ʤꤵ줿ȤȤǤ
				// åԥ󥰤Τ褦ʤΤǽλ
				fprintf(stderr, "clipeps: error: Specified PBM file is perfectly clear bitmap.\n");
				free(pixelData);
				return ERROR_NO_PIXEL;
			}
fin1:

			//
			// 2. βü˸äƽĴ٤ơ
			//    ԥ뤬Yɸõ
			//
			VerbosePrint("Start clipping phase 2...\n");
			{
				int x, y;

				for (y = (height - 1) ; y >= 0 ; y--)
				{
					for (x = 0 ; x < bytesWidth ; x++)
					{
						if (pixelData[y * bytesWidth + x] != 0)
						{
							leftY = y;
							goto fin2;
						}
					}
				}
			}
fin2:

			//
			// 3. αü麸˸äƽĴ٤ơ
			//    ԥ뤬Xɸõ
			//
			VerbosePrint("Start clipping phase 3...\n");
			{
				int x, y;
				int data;

				for (x = (bytesWidth - 1) ; x >= 0 ; x--)
				{
					for (y = 0 ; y < height ; y++)
					{
						data = pixelData[y * bytesWidth + x];
						if (data != 0)
						{
							rightX = x * 8;
							if      (data &   1) rightX += 7;
							else if (data &   2) rightX += 6;
							else if (data &   4) rightX += 5;
							else if (data &   8) rightX += 4;
							else if (data &  16) rightX += 3;
							else if (data &  32) rightX += 2;
							else if (data &  64) rightX += 1;
//							else if (data & 128) rightX += 0;		// ʤƤ

							goto fin3;
						}
					}
				}
			}
fin3:

			//
			// 4. ξü鲼˸äƽĴ٤ơ
			//    ԥ뤬Yɸõ
			//
			VerbosePrint("Start clipping phase 4...\n");
			{
				int x, y;

				for (y = 0 ; y < height ; y++)
				{
					for (x = 0 ; x < bytesWidth ; x++)
					{
						if (pixelData[y * bytesWidth + x] != 0)
						{
							rightY = y;
							goto fin4;
						}
					}
				}
			}
fin4:

			//
			// 줿Yɸ򡤲κǲ饤 Y=0 Ȥʤ褦ȿž
			//
			leftY  = height - leftY;
			rightY = height - rightY;

			//
			// ԥñ̤ǤBoundingBox׻λ
			//

			//
			// DPIͤȤˡԥ뤫ݥȤñ̤򴹻
			//
			VerbosePrint("Resolution: %d dpi\n", resolution);
			leftX  = (leftX  * 72) / resolution - 1;		// ; 1pt ĤƤ
			leftY  = (leftY  * 72) / resolution - 1;
			rightX = (rightX * 72) / resolution + 2;
			rightY = (rightY * 72) / resolution + 1;
			VerbosePrint("Calculated the new %%%%BoundingBox: %d %d %d %d\n", leftX, leftY, rightX, rightY);
		}

		//
		// ԥǡ˴
		//
		free(pixelData);
	}

	//
	// åԥ󥰸EPSե
	//
	VerbosePrint("Set the new %%%%BoundingBox value to the EPS file...\n");
	{
		//
		// EPSե򥪡ץ󤹤
		//
		VerbosePrint("Opening input EPS file \"%s\"...\n", fileName);
		{
			fpIn = fopen(fileName, "r");
			if (fpIn == NULL)
			{
				fprintf(stderr, "clipeps: error: Can't open the Encapsulated PostScript file for input - \"%s\"\n", fileName);
				return ERROR_FILE_NOT_OPENED;
			}
		}
		VerbosePrint("Opened input EPS file.\n");

		//
		// EPSե򥪡ץ󤹤
		//
		VerbosePrint("Opening output EPS file \"%s\"...\n", TEMPORARY_OUTPUT_FILENAME);
		{
			fpOut = fopen(TEMPORARY_OUTPUT_FILENAME, "w");
			if (fpOut == NULL)
			{
				fprintf(stderr, "clipeps: error: Can't open the Encapsulated PostScript file for output - " TEMPORARY_OUTPUT_FILENAME "\n");
				return ERROR_FILE_NOT_OPENED;
			}
		}
		VerbosePrint("Opened output EPS file.\n");

		//
		// EPSեBoundingBoxͤʬ򺹤ؤ
		//
		VerbosePrint("Writing to output EPS file...\n");
		{
			char buffer[BUFFER_SIZE];
			int  leftX_before,  leftY_before;
			int  rightX_before, rightY_before;

			// "%%BoundingBox: "ʳιԤϤҤ񤭹
			while (fgets(buffer, BUFFER_SIZE, fpIn) != NULL)
			{
				if (strncmp(buffer, "%%BoundingBox: ", 15) == 0)
				{
					char dummy[BUFFER_SIZE];

					if (sscanf(buffer, "%s %d %d %d %d", dummy, &leftX_before, &leftY_before, &rightX_before, &rightY_before) == 5)
					{
						// BoundingBoxεʬ򸫤Ĥؤ
						fprintf(fpOut, "%%%%BoundingBox: %d %d %d %d\n", leftX, leftY, rightX, rightY);
						VerbosePrint("Congratulations!  %%%%BoundingBox has been changed!\n");
					}
				}
				else
				{
					fputs(buffer, fpOut);
				}
			}
		}
		VerbosePrint("Wrote to output EPS file.\n");

		//
		// EPSե򥯥
		//
		{
			fclose(fpIn);
			fclose(fpOut);
		}
	}

	// Ǹˡϥեϥե˾񤭤
	VerbosePrint("Copying output EPS file to the input EPS file...\n");
	rename(TEMPORARY_OUTPUT_FILENAME, fileName);
	VerbosePrint("Copied successfully.\n");

	// 
	VerbosePrint("Output to file \"%s\"\n", fileName);
	VerbosePrint("Complete successfully.\n");

	return EXIT_SUCCESS;
}
